'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _uxcoreButton = require('uxcore-button');

var _uxcoreButton2 = _interopRequireDefault(_uxcoreButton);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SearchBar = require('./SearchBar');

var _SearchBar2 = _interopRequireDefault(_SearchBar);

var _ColumnPickerNew = require('./ColumnPickerNew');

var _ColumnPickerNew2 = _interopRequireDefault(_ColumnPickerNew);

var _LinkBar = require('./LinkBar');

var _LinkBar2 = _interopRequireDefault(_LinkBar);

var _CheckBox = require('../Cell/CheckBox');

var _CheckBox2 = _interopRequireDefault(_CheckBox);

var _RowOrder = require('./RowOrder');

var _RowOrder2 = _interopRequireDefault(_RowOrder);

var _ColumnOrder = require('./ColumnOrder');

var _ColumnOrder2 = _interopRequireDefault(_ColumnOrder);

var _uxcoreIcon = require('uxcore-icon');

var _uxcoreIcon2 = _interopRequireDefault(_uxcoreIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Grid Component for uxcore
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author zhouquan.yezq
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2014-2015, UXCore Team, Alinw.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var ActionBar = function (_React$Component) {
  _inherits(ActionBar, _React$Component);

  /**
   *  convert ActionBar config from hash to array
   */
  ActionBar.getActionItem = function getActionItem(config, isListActionBar) {
    var items = [];
    if (isListActionBar) {
      return config.buttons || [];
    }
    if (config instanceof Array) {
      items = config;
    } else if ((typeof config === 'undefined' ? 'undefined' : _typeof(config)) === 'object') {
      Object.keys(config).forEach(function (item) {
        var callback = config[item];
        if (typeof callback === 'function') {
          items.push({
            title: item,
            callback: callback
          });
        }
      });
    }
    return items;
  };

  function ActionBar(props) {
    var _this2 = this;

    _classCallCheck(this, ActionBar);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.handleCheckBoxChange = function (e) {
      var v = e.target.checked;
      _this.props.selectAll.apply(null, [v]);
    };

    _this.changeView = function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(e) {
        var _this$props, useCustomView, actionBarConfig, data, currentPage, renderCustomView, removePagerInCustomView, target, name, view;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props = _this.props, useCustomView = _this$props.useCustomView, actionBarConfig = _this$props.actionBarConfig, data = _this$props.data, currentPage = _this$props.currentPage;
                renderCustomView = actionBarConfig.renderCustomView, removePagerInCustomView = actionBarConfig.removePagerInCustomView;
                target = e.target;
                name = target.getAttribute('data-name');

                if (name) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt('return');

              case 6:
                _this.setState({
                  activatedView: name
                });

                if (!(name === 'custom')) {
                  _context.next = 14;
                  break;
                }

                _context.next = 10;
                return renderCustomView(data, currentPage);

              case 10:
                view = _context.sent;

                if (view && (typeof view === 'undefined' ? 'undefined' : _typeof(view)) === 'object' && view.type && view.props && name !== 'table') {
                  useCustomView(view, removePagerInCustomView);
                }
                _context.next = 15;
                break;

              case 14:
                useCustomView(null);

              case 15:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    _this.state = {
      activatedView: 'table'
    };
    return _this;
  }

  ActionBar.prototype.handleSearch = function handleSearch(value) {
    this.props.onSearch(value);
  };

  ActionBar.prototype.renderActionBtn = function renderActionBtn(item, index) {
    var me = this;
    var itemProps = {
      className: me.props.prefixCls + '-item',
      onClick: item.callback || function () {},
      type: item.type || 'secondary',
      key: index
    };
    if (!!item.render && typeof item.render === 'function') {
      return _react2["default"].createElement(
        'div',
        itemProps,
        item.render(item.title)
      );
    }
    if (index === 0 && !me.props.actionBarConfig.useListActionBar) {
      itemProps.type = 'outline';
    }
    return _react2["default"].createElement(
      _uxcoreButton2["default"],
      _extends({
        size: item.size || 'small',
        disabled: (me.state.activatedView !== 'table' || item.disabled) && !item.keepActiveInCustomView
      }, itemProps),
      item.title
    );
  };

  ActionBar.prototype.renderLinkBar = function renderLinkBar() {
    var me = this;
    var _me$props = me.props,
        linkBar = _me$props.linkBar,
        tablePrefixCls = _me$props.tablePrefixCls;

    return _react2["default"].createElement(_LinkBar2["default"], { config: linkBar, prefixCls: tablePrefixCls + '-linkbar' });
  };

  ActionBar.prototype.renderSearchBar = function renderSearchBar() {
    if (this.props.showSearch) {
      var me = this;
      var searchBarProps = {
        onSearch: me.handleSearch.bind(me),
        key: 'searchbar',
        placeholder: me.props.searchBarPlaceholder,
        prefixCls: me.props.tablePrefixCls + '-searchbar'
      };
      return _react2["default"].createElement(_SearchBar2["default"], searchBarProps);
    }
    return null;
  };

  ActionBar.prototype.renderColumnPicker = function renderColumnPicker() {
    var me = this;
    var _me$props2 = me.props,
        columns = _me$props2.columns,
        handleColumnPickerChange = _me$props2.handleColumnPickerChange,
        handleColumnPickerCheckAll = _me$props2.handleColumnPickerCheckAll,
        checkboxColumnKey = _me$props2.checkboxColumnKey,
        showColumnPicker = _me$props2.showColumnPicker,
        showColumnPickerCheckAll = _me$props2.showColumnPickerCheckAll,
        width = _me$props2.width,
        locale = _me$props2.locale,
        tablePrefixCls = _me$props2.tablePrefixCls,
        actionBarConfig = _me$props2.actionBarConfig;

    if (!showColumnPicker) {
      return null;
    }
    var commonRenders = {
      columns: columns,
      locale: locale,
      dropdownMaxWidth: width,
      checkboxColumnKey: checkboxColumnKey,
      handleColumnPickerChange: handleColumnPickerChange,
      handleColumnPickerCheckAll: handleColumnPickerCheckAll,
      showColumnPickerCheckAll: showColumnPickerCheckAll,
      prefixCls: tablePrefixCls + '-column-picker'
    };
    if (!actionBarConfig || !actionBarConfig.useListActionBar) {
      return _react2["default"].createElement(_ColumnPickerNew2["default"], commonRenders);
    }
    var columnsPicker = actionBarConfig.columnsPicker,
        useListActionBar = actionBarConfig.useListActionBar;

    return _react2["default"].createElement(_ColumnPickerNew2["default"], _extends({}, commonRenders, columnsPicker, {
      isTableView: me.state.activatedView === 'table',
      useListActionBar: useListActionBar
    }));
  };

  ActionBar.prototype.renderSelectAll = function renderSelectAll() {
    var me = this;
    return _react2["default"].createElement(
      'span',
      { className: me.props.tablePrefixCls + '-select-all' },
      _react2["default"].createElement(_CheckBox2["default"], {
        key: 'actionBarSelectAll',
        checked: me.props.checkStatus.isAllChecked,
        halfChecked: me.props.checkStatus.isHalfChecked,
        disable: me.props.checkStatus.isAllDisabled,
        onChange: me.handleCheckBoxChange,
        text: '全选'
      })
    );
  };

  ActionBar.prototype.renderListActionBar = function renderListActionBar() {
    var me = this;
    var _me$props$actionBarCo = me.props.actionBarConfig,
        useListActionBar = _me$props$actionBarCo.useListActionBar,
        showSelectAll = _me$props$actionBarCo.showSelectAll,
        actionBarTip = _me$props$actionBarCo.actionBarTip,
        renderCustomBarItem = _me$props$actionBarCo.renderCustomBarItem,
        rowOrder = _me$props$actionBarCo.rowOrder,
        columnsOrder = _me$props$actionBarCo.columnsOrder,
        columnsPicker = _me$props$actionBarCo.columnsPicker,
        showPager = _me$props$actionBarCo.showPager,
        renderCustomView = _me$props$actionBarCo.renderCustomView;
    var activatedView = me.state.activatedView;
    var _me$props3 = me.props,
        columns = _me$props3.columns,
        handleColumnOrderChange = _me$props3.handleColumnOrderChange;


    if (!useListActionBar) {
      return null;
    }
    return _react2["default"].createElement(
      'div',
      { className: me.props.tablePrefixCls + '-list-action-bar' },
      _react2["default"].createElement(
        'div',
        { className: 'left' },
        showSelectAll ? me.renderSelectAll() : null,
        ActionBar.getActionItem(me.props.actionBarConfig, true).map(function (item, index) {
          return me.renderActionBtn(item, index);
        }),
        actionBarTip ? _react2["default"].createElement(
          'div',
          { style: { display: 'inline-block' } },
          typeof actionBarTip === 'string' ? actionBarTip : typeof actionBarTip === 'function' ? actionBarTip() : null
        ) : null
      ),
      renderCustomBarItem ? _react2["default"].createElement(
        'div',
        { style: { display: 'inline-block' } },
        typeof renderCustomBarItem === 'string' ? renderCustomBarItem : typeof renderCustomBarItem === 'function' ? renderCustomBarItem() : null
      ) : null,
      _react2["default"].createElement(
        'div',
        { className: 'right' },
        renderCustomView ? _react2["default"].createElement(
          'div',
          { onClick: this.changeView },
          _react2["default"].createElement(_uxcoreIcon2["default"], { usei: true, className: (0, _classnames2["default"])({
              active: activatedView === 'table'
            }), 'data-name': 'table', name: 'renwufull' }),
          _react2["default"].createElement(_uxcoreIcon2["default"], { usei: true, className: (0, _classnames2["default"])({
              active: activatedView === 'custom'
            }), 'data-name': 'custom', name: 'biaoge1' })
        ) : null,
        showPager ? _react2["default"].createElement(
          'div',
          { style: { paddingTop: '5px' } },
          this.props.renderPager(true)
        ) : null,
        columnsPicker ? this.renderColumnPicker() : null,
        columnsOrder ? _react2["default"].createElement(_ColumnOrder2["default"], _extends({}, columnsOrder, {
          handleColumnOrderChange: handleColumnOrderChange,
          columns: columns,
          isTableView: activatedView === 'table'
        })) : null,
        rowOrder ? _react2["default"].createElement(_RowOrder2["default"], _extends({}, rowOrder, {
          isTableView: activatedView === 'table'
        })) : null
      )
    );
  };

  ActionBar.prototype.render = function render() {
    var me = this;
    var props = me.props;

    var actionBarConfig = props.actionBarConfig;
    var useListActionBar = actionBarConfig && actionBarConfig.useListActionBar;
    return _react2["default"].createElement(
      'div',
      {
        className: (0, _classnames2["default"])(props.tablePrefixCls + '-actionbar', {
          'fn-clear': true
        })
      },
      !useListActionBar ? ActionBar.getActionItem(actionBarConfig).map(function (item, index) {
        return me.renderActionBtn(item, index);
      }) : null,
      !useListActionBar ? me.renderSearchBar() : null,
      !useListActionBar ? me.renderColumnPicker() : null,
      !useListActionBar ? me.renderLinkBar() : null,
      useListActionBar ? me.renderListActionBar() : null
    );
  };

  return ActionBar;
}(_react2["default"].Component);

ActionBar.propTypes = {
  showSearch: _propTypes2["default"].bool,
  onSearch: _propTypes2["default"].func
};

ActionBar.defaultProps = {
  showSearch: false,
  onSearch: function onSearch() {}
};

exports["default"] = ActionBar;
module.exports = exports['default'];